<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { post } from "$lib/httpService";
  import BaseModal from "./BaseModal.svelte";

  const dispatch = createEventDispatcher();
  let name: string = "";
  let description: string = "";
  let start: Date = new Date();
  start.setDate(start.getDate() + 1);
  let end: Date = new Date();
  end.setDate(end.getDate() + 2);

  async function createEvent() {
    try {
      const response = await post("api/Event", {
        name,
        description,
        start,
        end,
      });

      dispatch("success");
    } catch (error) {
      console.error("Event creation failed:", error);
      alert("Event creation failed: " + error);
    }
  }

  function closeModal() {
    dispatch("close");
  }
</script>

<BaseModal on:close={closeModal}>
  <h2>Create Event</h2>
  <input type="text" bind:value={name} placeholder="Event Name" />
  <textarea bind:value={description} placeholder="Description"></textarea>
  <input type="datetime-local" bind:value={start} />
  <input type="datetime-local" bind:value={end} />
  <button on:click={createEvent}>Create Event</button>
  <button on:click={closeModal}>Cancel</button>
</BaseModal>
